#include <iostream>
#include "bio_bit_traits.h"

namespace std
{
  template<class _CharT, class _Traits, size_t __Nb>
  basic_istream<_CharT, _Traits>&
  operator>>(basic_istream<_CharT, _Traits>& __is, basic_string<bitset<__Nb>, bioinfo::na_nmer_overlap<__Nb> >& __x) {
    // for now let's do this super hoky style
    typedef typename _Traits::char_type char_type;
    static typename _Traits::int_type __eof = _Traits::eof();
    const std::size_t char_size = bioinfo::na_nmer_overlap<__Nb>::bit_size();
    const std::size_t left_bit_idx = (__Nb-1);
    bitset<__Nb> curr_bits;
    typename basic_istream<_CharT, _Traits>::sentry __sentry(__is);
    if (__sentry) {
      basic_streambuf<_CharT, _Traits>* __buf = __is.rdbuf();
	std::size_t pos = 0;
	bool dirty = false;
	for(;;) {
	  typename _Traits::int_type __c1 = __buf->sbumpc();
	  if (_Traits::eq_int_type(__c1, __eof)) {
	    __is.setstate(ios_base::eofbit);
	    break;
	  } else {
	    char_type __c2 = _Traits::to_char_type(__c1);
	    char_type __c  = __is.narrow(__c2, '*');
	    if(bioinfo::na_nmer_overlap<__Nb>::valid_code(__c)) {
	      dirty = true;
	      bitset<__Nb> tmp_bits = bioinfo::na_nmer_overlap<__Nb>::bit_code(__c);
	      if( pos > left_bit_idx ) {
		curr_bits=curr_bits<<char_size;
	      } else {
		size_t shift_width = left_bit_idx - pos - (char_size-1);
		tmp_bits=tmp_bits<<shift_width;
	      }
	      curr_bits |= tmp_bits;
	    } else if (_Traits::eq_int_type(__buf->sputbackc(__c2),__eof)) { 
	      __is.setstate(ios_base::failbit);
	      break;
	    } else {
	      //__buf->sputbackc(__c2);
	      break;
	    }
	  }
	  if(pos <= left_bit_idx)
	    pos += bioinfo::na_nmer_overlap<__Nb>::bit_size();
	  if( pos > left_bit_idx ) {
	    dirty = false;
	    __x.push_back(curr_bits);
	  }
	}
	if( dirty ) {
	  __x.push_back(curr_bits);
	}
	// do I need to check if something got read?
	if(  __x.empty() ) {
	  __is.setstate(ios_base::failbit);
	}
    }
    return __is;
  }

  template <class _CharT, class _Traits, size_t _Nb>
    basic_ostream<_CharT, _Traits>&
    operator<<(basic_ostream<_CharT, _Traits>& __os, const basic_string<bitset<_Nb>, bioinfo::na_nmer_overlap<_Nb> >& __x)
    {
      //cout<<"huh? __x.size: "<<__x.size()<<endl;
      for(unsigned i = 0; i < __x.size(); ++i) {
	//cout<<"i: "<<i<<endl;
        const bitset<_Nb>& bits = __x[i];
	// warning this restricts _Nb < 8&sizeof(unsigned long)
	// will probably need a better alternative here.
	__os<<bits.to_ulong(); 
	if( i < __x.size()-1 )
	  __os<<" ";
      }
      return __os;
    }

  template<size_t __Nb>
  bool
    operator==(const basic_string<bitset<__Nb>, bioinfo::na_nmer_overlap<__Nb> >& __x,
	     const string& str) {
    const std::size_t char_size = bioinfo::na_nmer_overlap<__Nb>::bit_size();
    const std::size_t left_bit_idx = (__Nb-1);
    bitset<__Nb> curr_bits;
    std::size_t pos = 0;
    bool dirty = false;
    unsigned biter = 0;
    for(unsigned i = 0; i < str.size();  ++i) {
      char __c = str[i];
      if(bioinfo::na_nmer_overlap<__Nb>::valid_code(__c)) {
	dirty = true;
	bitset<__Nb> tmp_bits = bioinfo::na_nmer_overlap<__Nb>::bit_code(__c);
	if( pos > left_bit_idx ) {
	  curr_bits=curr_bits<<char_size;
	} else {
	  size_t shift_width = left_bit_idx - pos - (char_size-1);
	  tmp_bits=tmp_bits<<shift_width;
	}
	curr_bits |= tmp_bits;
      } else {
	return false;
      }
      if(pos <= left_bit_idx)
	pos += bioinfo::na_nmer_overlap<__Nb>::bit_size();
      if( pos > left_bit_idx ) {
	dirty = false;
	// we've got a word, copmare
	if( __x[biter] != curr_bits ) {
	  return false;
	}
	++biter;
      }
    }
    if( dirty ) {
      if( __x[biter] != curr_bits ) {
	return false;
      }
      ++biter;
    }
    return true;
  }


}
